算法训练营(day31)

贪心算法理论基础

贪心的本质是选择每一阶段的局部最优,从而达到全局最优

举个例子,在规定次数内从一堆钞票里怎么拿面额最大的钞票,根据贪心算法的思想:每次拿最大的就好(够贪就行O(∩_∩)O)

贪心算法一般分为如下四步:

  • 将问题分解为若干个子问题
  • 找出适合的贪心策略
  • 求解每一个子问题的最优解
  • 将局部最优解堆叠成全局最优解

总而言之,贪心算法的本质其实就是 找到局部最优解,再比较所有的局部最优,得到全局最优

455.分发饼干

题目链接:https://leetcode.cn/problems/assign-cookies/

假设你是一位很棒的家长,想要给你的孩子们一些小饼干。但是,每个孩子最多只能给一块饼干。

对每个孩子 i,都有一个胃口值 g[i],这是能让孩子们满足胃口的饼干的最小尺寸;并且每块饼干 j,都有一个尺寸 s[j] 。如果 s[j] >= g[i],我们可以将这个饼干 j 分配给孩子 i ,这个孩子会得到满足。你的目标是尽可能满足越多数量的孩子,并输出这个最大数值。

解题思路

解题过程:

思路一:先喂饱胃口大的

  1. 先将胃口值 g 和饼干尺寸 s 进行排序(我使用的是 升序)
  2. 从后往前取 s的尺寸,从 胃口大 的孩子开始投喂
  3. 如果最大尺寸的饼干能喂饱胃口大的孩子,则 count++,取次一等尺寸的饼干继续投喂孩子
  4. 直到没有饼干,或者饼干喂不饱孩子的时候,返回 count 结果

思路二:先喂饱胃口小的

  1. 先将胃口值 g 和饼干尺寸 s 进行排序(我使用的是 升序)
  2. 最小尺寸 的饼干投喂孩子,不满足则往后取大一号的饼干
  3. 如果饼干能喂饱孩子,则 count++,继续投喂下一个孩子
  4. 直到没有饼干,或者饼干喂不饱孩子的时候,返回 count 结果

详细代码

思路一:先喂饱胃口大的

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
class Solution {
public int findContentChildren(int[] g, int[] s) {
Arrays.sort(g);
Arrays.sort(s);

int count = 0;
int start = s.length - 1;

for (int i = g.length - 1; i >= 0; i--){
if (start >= 0 && g[i] <= s[start]){
start--;
count++;
}
}
return count;
}
}

思路二:先喂饱胃口小的

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
class Solution {
public int findContentChildren(int[] g, int[] s) {
Arrays.sort(g);
Arrays.sort(s);

int start = 0;
int count = 0;
for (int i = 0; i < s.length && start < g.length; i++){
if (s[i] >= g[start]){
start++;
count++;
}
}
return count;
}
}

376.摆动序列

题目链接:https://leetcode.cn/problems/wiggle-subsequence/

如果连续数字之间的差严格地在正数和负数之间交替,则数字序列称为 摆动序列 。第一个差(如果存在的话)可能是正数或负数。仅有一个元素或者含两个不等元素的序列也视作摆动序列。

  • 例如, [1, 7, 4, 9, 2, 5] 是一个 摆动序列 ,因为差值 (6, -3, 5, -7, 3) 是正负交替出现的。
  • 相反,[1, 4, 7, 2, 5][1, 7, 4, 5, 5] 不是摆动序列,第一个序列是因为它的前两个差值都是正数,第二个序列是因为它的最后一个差值为零。

子序列 可以通过从原始序列中删除一些(也可以不删除)元素来获得,剩下的元素保持其原始顺序。

解题思路

解题过程:

思路一:贪心

  1. 当只有一个数时,摆动序列的长度 count 为1
  2. 定义两个变量 当前差值curDiff上一个差值preDiff
  3. 定义判断条件
    • 如果 当前差值 和 上一个差值 结果为 一正一负,则 count++
  4. 当前差值 过渡到 上一个差值
  5. 返回 count

思路二:动态规划

  1. 定义 坡峰dp[i][0]坡谷dp[i][1]
  2. 默认 dp[0][0] = dp[0][1] = 1
  3. 定义两个变量 当前值i上一个值j
  4. 定义判断条件
    • 如果 nums[j] > nums[i],那么 i 就是坡谷,dp[i][1] = Math.max(dp[i][1], dp[j][0] + 1)
    • 如果 nums[j] < nums[i],那么 i 就是坡峰,dp[i][0] = Math.max(dp[i][0], dp[j][1] + 1)
  5. 返回坡峰坡谷的最大值

详细代码

思路一:贪心

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
class Solution {
public int wiggleMaxLength(int[] nums) {
if (nums.length < 2){
return nums.length;
}

int curDiff = 0; //当前差值
int preDiff = 0; //上一个差值
int count = 1;
for (int i = 1; i < nums.length; i++){
//得到当前差值
curDiff = nums[i] - nums[i - 1];

//如果当前差值和上一个差值为一正一负
//等于0的情况表示初始时的preDiff
if (curDiff > 0 && preDiff <= 0 || (curDiff < 0 && preDiff >= 0)){
count++;
preDiff = curDiff;
}
}
return count;
}
}

思路二:动态规划

1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
class Solution {
public int wiggleMaxLength(int[] nums) {
int dp[][] = new int[nums.length][2];

dp[0][0] = dp[0][1] = 1;

for (int i = 1; i < nums.length; i++){
dp[i][0] = dp[i][1] = 1;

for (int j = 0; j < i; j++){
if (nums[j] > nums[i]){
dp[i][1] = Math.max(dp[i][1], dp[j][0] + 1);
}
if (nums[j] < nums[i]){
dp[i][0] = Math.max(dp[i][0], dp[j][1] + 1);
}
}
}
return Math.max(dp[nums.length - 1][0], dp[nums.length - 1][1]);
}
}

53.最大子数组和

题目链接:https://leetcode.cn/problems/maximum-subarray/

给定一个整数数组 nums ,找到一个具有最大和的连续子数组(子数组最少包含一个元素),返回其最大和。

解题思路

解题过程:

思路一:贪心

  1. 定义 累加值 sum 和 累加起始位置 count

  2. 遍历

    • count 不断更新 累加最大值 和 下一个值 的大小
    • sum 不断更新 countsum 比较的最大值
  3. 返回 sum

思路二:动态规划

  1. 和贪心思路一样,写法有点改变而已

详细代码

解法一:贪心

1
2
3
4
5
6
7
8
9
10
11
12
class Solution {
public int maxSubArray(int[] nums) {
int count = nums[0];
int sum = nums[0];

for (int i = 1; i < nums.length; i++){
count = Math.max(count + nums[i], nums[i]);
sum = Math.max(sum, count);
}
return sum;
}
}

解法二:动态规划

1
2
3
4
5
6
7
8
9
10
11
12
13
class Solution {
public int maxSubArray(int[] nums) {
int[] dp = new int[nums.length];
dp[0] = nums[0];
int ans = dp[0];

for (int i = 1; i < nums.length; i++){
dp[i] = Math.max(dp[i - 1] + nums[i], nums[i]);
ans = Math.max(dp[i], ans);
}
return ans;
}
}